/*
 * Copyright 2010 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.unitesk.requality.eclipse.reports;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

import com.unitesk.requality.eclipse.Activator;
import com.unitesk.requality.report.IReportTemplate;
import com.unitesk.requality.tools.Requality;

public class RequirementsReport implements IReportTemplate {

    @Override
    public String getTemplatePath() {
        try {
            return Activator.getPath("templates/requirements/template.xml");
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public Map<String, Object> getData() {
        Map<String, Object> data = new HashMap<String, Object>();
        data.put("report", this );
        return data;
    }

    public static String htmlEscape( String str )
    {
        return Requality.htmlEscape( str );
    }
}
