package com.unitesk.requality.tests;

import static org.junit.Assert.assertTrue;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.junit.Test;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeStorage;
import com.unitesk.requality.eclipse.natures.ReqCatalogue;
import com.unitesk.requality.eclipse.tools.ResourceStorage;
import com.unitesk.requality.eclipse.tools.TreesTracker;
import com.unitesk.requality.tests.core.APITest;


public class ResourceStoreAPITest extends APITest{
    private IProject project;
    
    @Override
    protected TreeDB getDB() {
        return TreesTracker.getTracker().getTree(project);
    }
    
    @Override
    protected TreeStorage createStorage() {
        try {
            project = ResourcesPlugin.getWorkspace().getRoot()
                    .getProject("TestProject");
            project.delete(true, null);
            project.create(null);
            project.open(null);

            IProjectDescription description = project.getDescription();
            String[] natures = description.getNatureIds();
            String[] newNatures = new String[natures.length + 1];
            System.arraycopy(natures, 0, newNatures, 0, natures.length);
            newNatures[natures.length] = ReqCatalogue.ID;
            description.setNatureIds(newNatures);
            project.setDescription(description, null);

            return new ResourceStorage(project);
        } catch (CoreException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Test
    public void yesItIsJUnitTest() {
        assertTrue(true);
    }
}
