package com.unitesk.requality.tests.core;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

import java.util.HashSet;
import java.util.UUID;

import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.AttributeType;
import com.unitesk.requality.core.MemoryStorage;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;

// Все дельты можно разделить на 4 класса
// Добавление узла
// Удаление узла
// Изменение состояния узла
// Изменение иерархии

public class DeltaProcessingTest {
    private MemoryStorage storage;
    private TreeDB db;

    @Before
    public void setUp() {
        storage = new MemoryStorage();
        db = new TreeDB(storage);
    }

    @Test
    public void getRoot() {
        TreeNode root = db.getRootNode();
        assertNotNull(root);
        assertEquals(root, db.getRootNode());
    }

    @Test
    @Ignore
    public void newNodeCreation() {
        TreeNode root = db.getRootNode();
        TreeNode a = root.createChild("a");

        UUID nnUUID = UUID.randomUUID();
        String typeName = "Node";
        String nnId = "b";
        HashSet<Attribute> nnAttr = new HashSet<Attribute>();
        nnAttr.add(new Attribute(AttributeType.STRING, "attr", "value"));

        // TODO: think about synchronization
        storage.emulateDeltaCreate(a.getUUId(), nnUUID, typeName, nnId, nnAttr);

        TreeNode b = a.getChild(0);
        assertEquals(nnUUID, b.getUUId());
        assertEquals(typeName, b.getType());
        assertEquals(nnId, b.getId());
        for(Attribute attr: nnAttr) {
            assertEquals(attr.getValue(), b.getAttribute(attr.getKey()));
        }
    }
}
