package com.unitesk.requality.tests.merge;

import java.lang.reflect.InvocationTargetException;
import java.util.List;
import java.util.Map;

import com.unitesk.requality.merge.Fragment;
import com.unitesk.requality.merge.Location;
import com.unitesk.requality.merge.MergeProcessor;
import com.unitesk.requality.merge.Node;
import com.unitesk.requality.merge.Tree;

public class MergeProcessorAccessor {

    private MergeProcessor MPInstance;

    public MergeProcessorAccessor(MergeProcessor instance) {
	this.MPInstance = instance;
    }

    public void checkIds(List<Location> locations)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { List.class };
	Object argValues[] = { locations };
	Utils.invokePrivateMethod(MPInstance, "checkIds", argTypes, argValues);
    }

    @SuppressWarnings("unchecked")
    public List<Location> lookupLocations(Tree t)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { Tree.class };
	Object argValues[] = { t };
	return (List<Location>) Utils.invokePrivateMethod(MPInstance,
		"lookupLocations", argTypes, argValues);
    }

    @SuppressWarnings("unchecked")
    public Map<Node, Fragment> makeFragments(Map<Node, List<Location>> mapping)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { Map.class };
	Object argValues[] = { mapping };
	return (Map<Node, Fragment>) Utils.invokePrivateMethod(MPInstance,
		"makeFragments", argTypes, argValues);
    }

    @SuppressWarnings("unchecked")
    public Map<Node, List<Location>> mapLocations(List<Location> locations)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { List.class };
	Object argValues[] = { locations };
	return (Map<Node, List<Location>>) Utils.invokePrivateMethod(
		MPInstance, "mapLocations", argTypes, argValues);
    }

    public void mergeFragment(Fragment f, Node n)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { Fragment.class, Node.class };
	Object argValues[] = { f, n };
	Utils.invokePrivateMethod(MPInstance, "mergeFragment", argTypes,
		argValues);
    }

    public Node traceLocation(Location loc, Tree t)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { Location.class, Tree.class };
	Object argValues[] = { loc, t };
	return (Node) Utils.invokePrivateMethod(MPInstance, "traceLocation",
		argTypes, argValues);
    }

    @SuppressWarnings("unchecked")
    public List<Location> traceLocations(List<Location> locations, Tree t)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { List.class, Tree.class };
	Object argValues[] = { locations, t };
	return (List<Location>) Utils.invokePrivateMethod(MPInstance,
		"traceLocations", argTypes, argValues);
    }

    @SuppressWarnings("unchecked")
    public List<Location> updateLocations(List<Location> locations)
	    throws InvocationTargetException {
	Class<?> argTypes[] = { List.class };
	Object argValues[] = { locations };
	return (List<Location>) Utils.invokePrivateMethod(MPInstance,
		"updateLocations", argTypes, argValues);
    }
}
