package swtbotforrequality;

import static org.junit.Assert.*;

import org.eclipse.swtbot.eclipse.finder.SWTWorkbenchBot;
import org.eclipse.swtbot.eclipse.finder.widgets.SWTBotEditor;
import org.eclipse.swtbot.eclipse.finder.widgets.SWTBotView;
import org.eclipse.swtbot.swt.finder.junit.SWTBotJunit4ClassRunner;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotShell;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTree;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTreeItem;
import org.junit.AfterClass;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;
 
@RunWith(SWTBotJunit4ClassRunner.class)
public class CreateProject {
 
	private static SWTWorkbenchBot	bot;
 
	@BeforeClass
	public static void beforeClass() throws Exception {
		bot = new SWTWorkbenchBot();
		bot.viewByTitle("Welcome").close();
	}
 
 
	@Test
	public void canCreateANewJavaProject() throws Exception {
		System.out.println("Begin testing");
		bot.menu("File").menu("New").menu("Other...").click();

		SWTBotShell shell = bot.shell("New");
		shell.activate();
		assertNotNull(bot.tree().expandNode("Requality").getNode("Requality Project"));
		bot.tree().expandNode("Requality").select("Requality Project");
		bot.button("Next >").click();
		bot.textWithLabel("Project name:").setText("ReqProject");
		bot.button("Finish").click();
		boolean ok = false;
		for( SWTBotView view: bot.views()) {
			if(view.getTitle().equals("Requality Explorer")) {
				ok = true;
				break;
			}
		}
		assertTrue("\"Requality Explorer\" view doesn't exist", ok);
		SWTBotTree projectTree = bot.viewByTitle("Requality Explorer").bot().tree();
		boolean tr = false;
		for ( SWTBotTreeItem  proj : projectTree.getAllItems()) {
			if (proj.getText().equals("ReqProject"))
				tr = true;
			break;
		}
		assertTrue(tr); // "ReqProject" project exists.
		bot.activeView();
		
	}
 
 
	@AfterClass
	public static void sleep() {
		bot.sleep(2000);
	}
 
}